/* bitmap loading code by gammy. */

/* Error codes */
#define BMP_NOFILE          1	/* The file does not exist  */
#define BMP_NOBITMAP        2	/* The file is not a bitmap */
#define BMP_CORRUPTFILE     3	/* The file is corrupted    */
#define BMP_NOSUPPORTRLE    4	/* The file uses unsupported compression */
#define BMP_NOSUPPORTBPP    5	/* The file uses an unsupported bitdepth */
#define BMP_NOMEMORY        6	/* Not enough memory to load file */

/* Bitmap types */
#define BMP_RLE_4BPP        2
#define BMP_RLE_8BPP        1
#define BMP_NORLE           0

/* RLE second byte values */
#define BMP_RLE_EOL         0
#define BMP_RLE_EOB         1
#define BMP_RLE_DELTA       2

/* Bitmap signature */
#define BMSIGNATURE         "BM"

char errortext[20];

typedef struct bitmapEx {
    short width;
    short height;
    short bpp;
    short usedcolors;
    long imagesize;
    long compression;
    char *image;

    struct paletteEx {
	short r;
	short g;
	short b;
    } palette[256];

} bmp;
